﻿using HarmonyLib;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Reflection;

public class BiggerPlots : Mod
{
    public static AssetBundle assetbundle;

    public Harmony harmony;


    public IEnumerator Start()
    {
        HNotification notification = FindObjectOfType<HNotify>().AddNotification(HNotify.NotificationType.spinning, "Loading BiggerPlots...");

        // csrun foreach(Cropplot c in PlantManager.allCropplots) { c.mainCollider = c.GetComponents<BoxCollider>().ToList()[0]; }

        AssetBundleCreateRequest request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("biggerplots.assets"));
        yield return request;
        assetbundle = request.assetBundle;

        /*
        assetbundle = bundleLoadRequest.assetBundle;
        if (assetbundle == null)
        {
            RConsole.LogError("Failed to load AssetBundle for BiggerPlots!");
            notification.Close();
            yield return null;
        }
        */

        List<Item_Base> list = Traverse.Create(typeof(ItemManager)).Field("allAvailableItems").GetValue<List<Item_Base>>();

        Item_Base placeable_biggerplots_1x1 = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_biggerplots_1x1");
        placeable_biggerplots_1x1.Initialize(1167, "placeable_biggerplots_1x1", 1);


        Item_Base placeable_biggerplots_2x2 = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_biggerplots_2x2");
        placeable_biggerplots_2x2.Initialize(1168, "placeable_biggerplots_2x2", 1);


        Item_Base placeable_biggerplots_3x3 = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_biggerplots_3x3");
        placeable_biggerplots_3x3.Initialize(1169, "placeable_biggerplots_3x3", 1);


        Item_Base placeable_biggerplots_4x4 = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_biggerplots_4x4");
        placeable_biggerplots_4x4.Initialize(1170, "placeable_biggerplots_4x4", 1);


        Item_Base placeable_biggerplots_5x5 = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_biggerplots_5x5");
        placeable_biggerplots_5x5.Initialize(1171, "placeable_biggerplots_5x5", 1);


        Item_Base placeable_biggerplots_6x6 = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_biggerplots_6x6");
        placeable_biggerplots_6x6.Initialize(1172, "placeable_biggerplots_6x6", 1);


        Item_Base placeable_biggerplots_7x7 = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_biggerplots_7x7");
        placeable_biggerplots_7x7.Initialize(1173, "placeable_biggerplots_7x7", 1);


        Item_Base placeable_biggerplots_8x8 = (Item_Base)assetbundle.LoadAsset<ScriptableObject>("placeable_biggerplots_8x8");
        placeable_biggerplots_8x8.Initialize(1174, "placeable_biggerplots_8x8", 1);

        list.Add(placeable_biggerplots_1x1);
        list.Add(placeable_biggerplots_2x2);
        list.Add(placeable_biggerplots_3x3);
        list.Add(placeable_biggerplots_4x4);
        list.Add(placeable_biggerplots_5x5);
        list.Add(placeable_biggerplots_6x6);
        list.Add(placeable_biggerplots_7x7);
        list.Add(placeable_biggerplots_8x8);

        FixMainCollider(placeable_biggerplots_1x1);
        FixMainCollider(placeable_biggerplots_2x2);
        FixMainCollider(placeable_biggerplots_3x3);
        FixMainCollider(placeable_biggerplots_4x4);
        FixMainCollider(placeable_biggerplots_5x5);
        FixMainCollider(placeable_biggerplots_6x6);
        FixMainCollider(placeable_biggerplots_7x7);
        FixMainCollider(placeable_biggerplots_8x8);

        FixMaterial(placeable_biggerplots_1x1);
        FixMaterial(placeable_biggerplots_2x2);
        FixMaterial(placeable_biggerplots_3x3);
        FixMaterial(placeable_biggerplots_4x4);
        FixMaterial(placeable_biggerplots_5x5);
        FixMaterial(placeable_biggerplots_6x6);
        FixMaterial(placeable_biggerplots_7x7);
        FixMaterial(placeable_biggerplots_8x8);

        notification.Close();

        harmony = new Harmony("com.dcsobral.InventoryBeforeHotbar");
        harmony.PatchAll(Assembly.GetExecutingAssembly());

        yield return null;

    }
    void FixMainCollider(Item_Base newItem) {
        newItem.settings_buildable.GetBlockPrefab(0).GetComponent<Cropplot>().mainCollider = newItem.settings_buildable.GetBlockPrefab(0).GetComponents<BoxCollider>()[0];
    }

    void FixMaterial(Item_Base newItem)
    {
        newItem.settings_buildable.GetBlockPrefab(0).gameObject.layer = 10;
        newItem.settings_buildable.GetBlockPrefab(0).GetComponent<Cropplot>().acceptableItemTypes = ItemManager.GetItemByName("Placeable_Cropplot_Medium").settings_buildable.GetBlockPrefab(0).GetComponent<Cropplot>().acceptableItemTypes;
        newItem.settings_buildable.GetBlockPrefab(0).GetComponent<Cropplot>().acceptableItemTypes.AddRange(ItemManager.GetItemByName("Placeable_Cropplot_Large").settings_buildable.GetBlockPrefab(0).GetComponent<Cropplot>().acceptableItemTypes);
        //newItem.settings_buildable.GetBlockPrefab(0).GetComponent<Cropplot>().acceptableItemTypes.Add(ItemManager.GetItemByName("Seed_Palm"));

        Material plotMat = ItemManager.GetItemByName("Placeable_Cropplot_Small").settings_buildable.GetBlockPrefab(0).GetComponentInChildren<Renderer>().material;
        Material dirtMat = ItemManager.GetItemByName("Placeable_Cropplot_Small").settings_buildable.GetBlockPrefab(0).GetComponentsInChildren<Renderer>()[1].material;

        foreach (Renderer rnd in newItem.settings_buildable.GetBlockPrefab(0).GetComponentsInChildren<Renderer>())
        {
            rnd.material = dirtMat;
        }


        newItem.settings_buildable.GetBlockPrefab(0).GetComponentsInChildren<Renderer>()[0].material = plotMat;

        RAPI.AddItemToBlockQuadType(newItem, RBlockQuadType.quad_floor);
        RAPI.AddItemToBlockQuadType(newItem, RBlockQuadType.quad_foundation);
    }

    public void Update()
    {

    }

    public void OnModUnload()
    {
        harmony.UnpatchAll();
        Debug.Log("BiggerPlots can't be unloaded!");
    }
}
/*
[HarmonyPatch(typeof(Seagull), "FindCropplotAndNest")]
public class HarmonyPatch_InventoryBeforeHotbar {
    [HarmonyPrefix]
    static bool FindCropplotAndNest(Seagull __instance, bool ___reachedAltitude, float ___searchPlayerRadius, float ___searchScarecrowRadius) {
        if (!___reachedAltitude) {
            return false;
        }
        if (GameModeValueManager.GetCurrentGameModeValue().seagullVariables.attacksCrops) {
            foreach (Cropplot cropplot in PlantManager.allCropplots) {
                if (cropplot.peckable && cropplot.ContainsCrops) {
                    Vector3 c = cropplot.mainCollider.center;
                    BoxCollider bC = cropplot.mainCollider;
                    Transform t = bC.transform;
                    Vector3 vector = t.TransformPoint(c);

                    if (HarmonyPatch_InventoryBeforeHotbar.CheckVisionToObject<Cropplot>(__instance, cropplot, vector, "Cropplot", QueryTriggerInteraction.Ignore) && !HarmonyPatch_InventoryBeforeHotbar.PlayerIsWithinVicinity(__instance, vector, ___searchPlayerRadius)) {
                        bool flag = false;
                        Scarecrow scarecrowInVicinity = HarmonyPatch_InventoryBeforeHotbar.GetScarecrowInVicinity(__instance, vector, ___searchScarecrowRadius, ref flag);
                        if (scarecrowInVicinity == null) {
                            if (flag) {
                                return false;
                            }
                            __instance.targetCropplot = cropplot;
                            __instance.targetPoint = __instance.GetBirdlandingPos(__instance.targetCropplot.transform);
                            __instance.SwitchState(SeagullState.Dive);
                            return false;
                        } else if (!scarecrowInVicinity.invurnerable) {
                            __instance.targetScarecrow = scarecrowInVicinity;
                            __instance.targetScarecrow.Occupied = true;
                            __instance.targetPoint = __instance.GetBirdlandingPos(__instance.targetScarecrow.transform);
                            __instance.SwitchState(SeagullState.Dive);
                            return false;
                        }
                    }
                }
            }
        }
        foreach (BirdsNest birdsNest in BirdsNest.AllNests) {
            if (!birdsNest.Occuppied) {
                Transform birdlandingPos = __instance.GetBirdlandingPos(birdsNest.transform);
                Vector3 vector2 = (birdlandingPos != null) ? birdlandingPos.position : birdsNest.transform.position;

                if (HarmonyPatch_InventoryBeforeHotbar.CheckVisionToObject<BirdsNest>(__instance, birdsNest, vector2, "BirdsNest", QueryTriggerInteraction.Collide) && !HarmonyPatch_InventoryBeforeHotbar.PlayerIsWithinVicinity(__instance, vector2, ___searchPlayerRadius)) {
                    __instance.currentNest = birdsNest;
                    __instance.currentNest.Occuppied = true;
                    __instance.targetPoint = __instance.GetBirdlandingPos(__instance.currentNest.transform);
                    __instance.SwitchState(SeagullState.Dive);
                    break;
                }
            }
        }
        return false;
    }
    private static bool PlayerIsWithinVicinity(Seagull __instance, Vector3 point, float radius) {
        MethodInfo playerIsWithinVicinityMethod = __instance.GetType().GetMethod("PlayerIsWithinVicinity", BindingFlags.NonPublic | BindingFlags.Instance);
        object[] methodParams = new object[]
        {
                        point, radius
        };
        bool playerIsWithinVicinity = (bool)playerIsWithinVicinityMethod.Invoke(__instance, methodParams);
        
        return playerIsWithinVicinity;
    }
    private static bool CheckVisionToObject<T>(Seagull __instance, T objectToCompare, Vector3 raycastTargetPoint, string tagToCheck, QueryTriggerInteraction hitTriggers) where T : MonoBehaviour {
        MethodInfo checkVisionToObjectMethod = __instance.GetType().GetMethod("CheckVisionToObject", BindingFlags.NonPublic | BindingFlags.Instance);
        object[] methodParams = new object[]
        {
                        objectToCompare, raycastTargetPoint, tagToCheck, hitTriggers
        };
        MethodInfo genericMethod = checkVisionToObjectMethod.MakeGenericMethod(typeof(T));
        bool checkVisionToObject = (bool)genericMethod.Invoke(__instance, methodParams);
        
        return checkVisionToObject;
    }
    private static Scarecrow GetScarecrowInVicinity(Seagull __instance, Vector3 point, float radius, ref bool scarecrowWasNearbyButNotValid) {
        MethodInfo getScarecrowInVicinityMethod = __instance.GetType().GetMethod("GetScarecrowInVicinity", BindingFlags.NonPublic | BindingFlags.Instance);
        object[] methodParams = new object[]
        {
                        point, radius, scarecrowWasNearbyButNotValid
        };
        Scarecrow getScarecrowInVicinity = (Scarecrow)getScarecrowInVicinityMethod.Invoke(__instance, methodParams);

        return getScarecrowInVicinity;
    }
}
*/